﻿//================================================
/*
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/grplugins


    This file is part of the 'US Pop Clock' gadget.

    US Pop Clock is licensed under the Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License. 
    To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/3.0/us/ or send a letter to 
    Creative Commons, 543 Howard Street, 5th Floor, San Francisco, California, 94105, USA.

    US Pop Clock is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 


*/
//================================================

/*function resetimgopac(){
birth.opacity=75;
death.opacity=75;
immigrant.opacity=75;
}*/



function view_onOpen()
{
//bg set
options.DefaultValue( MILKTHEME_COLOR ) = COLORS[ 0 ];
Face.background = options( MILKTHEME_COLOR );
//update check
pluginHelper.onAddCustomMenuItems = onAddCustomMenuItems;
checkupdate();
//start pop clock
startclock();
}

//---
//add menu item
//---
function onAddCustomMenuItems(menu) {
  // Add each item. Note that this needs to be done each time this function is
  // called.
  menu.AddItem("Check for Update", 0, checkupdatea);
function checkupdatea(){checkupdate("frommenu")}
}


function startclock(){

//load the xml
var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
function loadXML(xmlFile)
{
 xmlDoc.async="false";
 xmlDoc.onreadystatechange=verify;
 xmlDoc.load(xmlFile);
 xmlObj=xmlDoc.documentElement;
}
function verify()
{
 // 0 Object is not initialized
 // 1 Loading object is loading data
 // 2 Loaded object has loaded data
 // 3 Data from object can be worked with
 // 4 Object completely initialized
 if (xmlDoc.readyState != 4)
 {
   return false;
 }
}
try{
loadXML('http://www.census.gov/main/www/rss/popclocks.xml');

//output full xml
//alert(xmlObj.xml);
xmldatavar = xmlObj.childNodes(0).childNodes(6).firstChild.text;
xmldatavar = xmldatavar.split("\n");
xmldatavar = xmldatavar[1].split(" ");
populationis = xmldatavar[0].replace(/\,/g,"");
populationis = parseInt(populationis);
poplbl.innerText = populationis;
//start update
startUpdateInt();
}
catch (e){
//alert("Error syncing clock to current population. Please check your network connection.")
poplbl.innerText = "-NETWORK-";
errorlbl.visible=true;
pausebut.onclick="endClock('false')";
pausebut.downImage="play.png";
pausebut.image="play.png";
pausebut.overImage="play.png";
}
}




function startUpdateInt(){
resyncclockobj = setInterval("resyncclock()", 600000); //resync to census.gov clock every 10 min
updateclockobjbirth = setInterval("updateClockbirth()", 8000); //birth every 8 seconds
updateclockobjdeath = setInterval("updateClockdeath()", 12000); //death every 12 seconds
updateclockobjimmigrant = setInterval("updateClockimmigrant()", 26000);  //immigrant every 26 seconds
}

function endClock(tf){
if(tf=="true"){
pauselbl.visible=true;
pausebut.onclick="endClock('false')";
pausebut.downImage="play.png";
pausebut.image="play.png";
pausebut.overImage="play.png";
clearInterval(resyncclockobj);
clearInterval(updateclockobjbirth);
clearInterval(updateclockobjdeath);
clearInterval(updateclockobjimmigrant);
}
else{
pauselbl.visible=false;
errorlbl.visible=false;
pausebut.onclick="endClock('true')";
pausebut.downImage="pause.png";
pausebut.image="pause.png";
pausebut.overImage="pause.png";
startclock();
}
}

function resyncclock(){
clearInterval(resyncclockobj);
clearInterval(updateclockobjbirth);
clearInterval(updateclockobjdeath);
clearInterval(updateclockobjimmigrant);
poplbl.innerText = "RESYNCING";
startclock();
}



//fade atuff

var first_opac = 75;
var sec_opac =400;
//var opacb = first_opac;
//var opacd = first_opac;
//var opaci = first_opac;
var speedb = 6;
var speedd = 6;
var speedi = 6;
var sib;
var sid;
var sii;
var clearedb = true;
var clearedd = true;
var clearedi = true;


function updateClockbirth(){
populationis = eval(populationis+1);
poplbl.innerText = populationis;
//event.innerText ="Birth";
//ClearInt();
sib=setInterval("showimageb('birth',true)",10);
}

function updateClockdeath(){
populationis = eval(populationis-1);
poplbl.innerText = populationis;
//event.innerText ="Death";
//ClearInt();
sid=setInterval("showimaged('death',true)",10);
}

function updateClockimmigrant(){
populationis = eval(populationis+1);
poplbl.innerText = populationis;
//event.innerText ="Immigrant";
//ClearInt();
sii=setInterval("showimagei('immigrant',true)",10);
}


function showimageb(what,doshow) {

  clearedb = false;
  (doshow) ? birth.opacity+=speedb : birth.opacity-=speedb;//opacb
//  eval(what+".opacity="+opacb);
  if (birth.opacity >= sec_opac) {
    clearInterval(sib);
    clearedb = true;
    speedb = 7;
    sib=setInterval("showimageb('birth',false)",10);
  }
else if (birth.opacity <= first_opac) {
    clearInterval(sib);
    clearedb = true;
    speedb = 16;
  }

if(birth.opacity<40){
//alert("b is less than 0");
    clearInterval(sib);
    birth.opacity=75;
    clearedb = true;
    speedb = 16;
}
}

function showimaged(what,doshow) {

  clearedd = false;
  (doshow) ? death.opacity+=speedd : death.opacity-=speedd;//opacd
//  eval(what+".opacity="+opacd);
  if (death.opacity >= sec_opac) {
    clearInterval(sid);
    clearedd = true;
    speedd = 7;
    sid=setInterval("showimaged('death',false)",10);
  }
else if (death.opacity <= first_opac) {
    clearInterval(sid);
    clearedd = true;
    speedd = 16;
  }
}

function showimagei(what,doshow) {

  clearedi = false;
  (doshow) ? immigrant.opacity+=speedi : immigrant.opacity-=speedi;//opaci
//  eval(what+".opacity="+opaci);
  if (immigrant.opacity >= sec_opac) {
    clearInterval(sii);
    clearedi = true;
    speedi = 7;
    sii=setInterval("showimagei('immigrant',false)",10);
  }
else if (immigrant.opacity <= first_opac) {
    clearInterval(sii);
    clearedi = true;
    speedi = 16;
  }
}

//function ClearInt() {
//if (!cleared) clearInterval(si);
//}



//---
//Update Check
//---
function checkupdate(is_menu){
//check for an update
//load the xml
var updatexmlDoc = new ActiveXObject("Microsoft.XMLDOM");
function updateloadXML(uxmlFile)
{
 updatexmlDoc.async="false";
 updatexmlDoc.onreadystatechange=verify;
 updatexmlDoc.load(uxmlFile);
 updatexmlObj=updatexmlDoc.documentElement;
}

function verify()
{
 // 0 Object is not initialized
 // 1 Loading object is loading data
 // 2 Loaded object has loaded data
 // 3 Data from object can be worked with
 // 4 Object completely initialized
 if (updatexmlDoc.readyState != 4)
 {
   return false;
 }
}
try{
updateloadXML('http://glennrivkees.com/plugins/popclock/latestversion.xml');
//set version number vars
latestVis=updatexmlObj.childNodes(0).childNodes(1).text
versionis = GADGET_VERSION_NUM;
//set changes var
changesinver1 = updatexmlObj.childNodes(0).childNodes(2).childNodes(0).text
changesinver2 = updatexmlObj.childNodes(0).childNodes(2).childNodes(1).text
downloadurl = updatexmlObj.childNodes(0).childNodes(2).childNodes(2).text
//alert(updatexmlObj.childNodes(0).childNodes(1).text)
if(versionis!=latestVis){
alert("A newer version of the \"US Pop Clock\" gadget is availible.\nIt is recomended that you update. If the population is not loading this may fix the problem.\n\nYou currently have version "+versionis+" and the latest version is "+latestVis+".\n\n"+changesinver1+"\n"+changesinver2)
wanttodownload = confirm('Do you wish to go to the gadget download website?');
	if(wanttodownload==true){
	var winShell = new ActiveXObject("Shell.Application");
	winShell.ShellExecute(downloadurl); 
	}
}
else if(is_menu=="frommenu"){alert("You have the latest version.\n\nYou currently have version "+versionis+" and the latest version is "+latestVis+".")}
}
catch (e){
if(is_menu=="frommenu"){alert("Error checking for updates. Please check your network connection.")}
}
}