﻿//================================================
/*
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/grplugins


    This file is part of the 'US Pop Clock' gadget.

    This script was made by Google for their 'Wireless Signal Meter' gadget. 

    US Pop Clock is licensed under the Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License. 
    To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/3.0/us/ or send a letter to 
    Creative Commons, 543 Howard Street, 5th Floor, San Francisco, California, 94105, USA.

    US Pop Clock is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 


*/
//================================================

var MILKTHEME_COLOR = "MilkTheme_Color";

var COLORS = new Array( 8 );
COLORS[ 0 ] = "#CECEC2"
COLORS[ 1 ] = "#FFA72B"
COLORS[ 2 ] = "#DEFF00"
COLORS[ 3 ] = "#89EFAA"
COLORS[ 4 ] = "#90D7FF"
COLORS[ 5 ] = "#B6B0FF"
COLORS[ 6 ] = "#D58CFF"
COLORS[ 7 ] = "#FF86EA"
options.DefaultValue( MILKTHEME_COLOR ) = COLORS[ 1 ];
//
// NextColor_OnMouseOver
//
function NextColor_OnMouseOver( MouseEvent )
{
  ColorButton.background = GetNextTheme();
}

//
// NextColor_OnMouseOut
//
function NextColor_OnMouseOut( MouseEvent )
{
  ColorButton.background = "#DDDDDD";
}


//
// NextColor_OnClick
//
function NextColor_OnClick( MouseEvent )
{
  var color = GetNextTheme();
  options( MILKTHEME_COLOR ) = color;
  ColorButton.background = color;
  Face.background = options( MILKTHEME_COLOR );
}

//
// GetNextTheme
//
function GetNextTheme()
{
  var CurrentColor = options( MILKTHEME_COLOR );

  var i = 0;
  for( ; i < COLORS.length; i++ )
  {
    if( COLORS[ i ] == CurrentColor )
    {
      break;
    }
  }
  
  i++;
  if( i >= COLORS.length )
  {
    i = 0;
  }
  
  return COLORS[ i ];
}
